//--------------------------------------------------------------------//
// f܂ł̋

var viewModel;			// \f
var canvas;			// LoXvf
var context;	 		// ReLXg
var planets=[];			// fXg
var thres;			// fEOf臒l
var maxRadius;			// z̋̍ől
var viewPoint1,viewPoint2;	// _ʒu
var epoch=2451545.0;		// EX
var julianDay;			// EX
var scale;			// ڐ
var planet1,planet2;		// fselectvf
var p1,p2;			// f|C^
var namePlate;			// fl[v[g
var receives=[];		// NbN肷IuWFNgef

// f^Cv
var SUN=0;			// z
var INNER_PLANET=1;		// f
var OUTER_PLANET=2;		// Of

var EPOCH_JD=2440587.5;		// 1970 N 1  1  00:00:00 GMT ̃EX
var MJD_EPOCH=2400000.5;	// EX̊_
var MILLIS_TO_DAY=1.0/8.64E7;	// Ԃ~b֕ϊW

var FONT_SIZE=15;			// tHgTCY
var FONT=FONT_SIZE+"px 'Arial'";	// tHg
var TO_RADIAN=Math.PI/180.0;		// pxWAɕϊW
var FG_COLOR='rgb(255,255,255)';	// OiF
var BG_COLOR='rgb(0,0,0)';		// wiF
var LIFT_MARGIN=15;			// ]
// fO̕\}eA
var ORBIT_MAT=new THREE.LineBasicMaterial({color:0xffffff});
// ڐ̕\}eA
var SCALE_AXIS_MAT=new THREE.LineBasicMaterial({color:0x99ffff});

var AU_TO_KM=1.4959787E8;	//  AU  km ֕ϊW
var ORBIT_VIEW_COUNT=360;	// O_̐
var TOLERANCE=1.0E-8;		// Pv[̋e덷

// f
// fileName - f[^t@C
function initPlanet(fileName){
  p1=-1;
  p2=-1;
  namePlate=null;
  readPlanetDataFile(fileName);
  viewModel=new ViewModel('planet-canvas');
  scale=new Scale();
  initObject();
  initCanvas();
  setSelect();
  loop();
}

// ff[^t@Cǂݍ
// fileName - f[^t@C
function readPlanetDataFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readPlanetData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// ff[^t@Cǂݍ
// s - f[^̃Xg
function readPlanetData(s){
  planets.length=0;
  var ss=s[0].trim().replace(/\t/g,' ').split(/\s+/),i;
  thres=Number(ss[1]);
  epoch=Number(ss[3]);
  maxRadius=0.0;

  for(i=2;i<s.length;i++){
    ss=s[i].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>9){
      var pinv=Number(ss[9]);
      if(pinv!==0.0){
      	pinv=2.0*Math.PI/(365.25*pinv);
      }
      var pl=new Planet(ss[0],ss[1],
      	      	      	Number(ss[2])+1,Number(ss[3]),Number(ss[4]),
      	      	      	TO_RADIAN*Number(ss[5]),
      	      	      	TO_RADIAN*Number(ss[6]),
      	      	      	TO_RADIAN*Number(ss[7]),
      	      	      	TO_RADIAN*Number(ss[8]),pinv);
      pl.setType(thres);
      planets.push(pl);
      maxRadius=Math.max(maxRadius,pl.getMaxRadius());
    }
  }
  if(planets.length>0){
    p1=0;
    p2=0;
  }
  viewPoint1=2.5*thres;
  viewPoint2=2.5*maxRadius;
  for(i=0;i<planets.length;i++){
    planets[i].createObject(i);
  }
}

// \IuWFNg
function initObject(){
  if(planets.length===0) return;
  for(var i=0;i<planets.length;i++){
    viewModel.addObject(planets[i].obj);
    if(planets[i].orbit!==undefined){
      viewModel.addObject(planets[i].orbit);
    }
  }
  viewModel.addObject(scale.obj);
  initMouseEvent();
}

// }EXCxg
function initMouseEvent(){
  var mouse=new THREE.Vector2();
  var raycaster=new THREE.Raycaster();
  for(var i=0;i<planets.length;i++){
    receives.push(planets[i].obj);
  }

  var cfx=2/viewModel.canvasFrame.clientWidth;
  var cfy=2/viewModel.canvasFrame.clientHeight;
  viewModel.canvasFrame.addEventListener
    ('mousedown',onMouseDown,false);

  function onMouseDown(event){
    var bcr=viewModel.canvasFrame.getBoundingClientRect();
    mouse.set(cfx*(event.clientX-bcr.left)-1,
      	      -(cfy*(event.clientY-bcr.top)-1));
    raycaster.setFromCamera(mouse,viewModel.camera);
    if(namePlate!==null){
      viewModel.removeObject(namePlate);
      namePlate=null;
    }
    var intersects=raycaster.intersectObjects(receives);
    if(intersects.length>0){
      var clck=parseInt(intersects[0].object.name);
      var text=document.createElement('div');
      text.style.font=FONT;
      text.style.color=FG_COLOR;
      text.style.backgroundColor=BG_COLOR;
      text.style.top='-0.5em';
      text.style.left=(0.5*planets[clck].name.length)+'em';
      text.textContent=planets[clck].name;
      namePlate=new THREE.CSS2DObject(text);
      namePlate.position.copy(intersects[0].point);
      viewModel.addObject(namePlate);
    }
  }
}

// LoX
function initCanvas(){
  canvas=document.getElementById('planet');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT;
  context.textBaseline='top';
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 73:		// I
      viewModel.initView();
      break;
    case 79:		// O
      viewModel.viewAll();
      break;
    case 107:		// Numpad+
    case 187:		// +
      movePointer(0,1);
      break;
    case 109:		// Numpad-
    case 189:		// -
      movePointer(0,-1);
      break;
    case 35:		// End(Numpad1 Off)
    case 49:		// 1
    case 97:		// Numpad1 On
      movePointer(1,1);
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 96:		// Numpad0 On
      movePointer(1,-1);
      break;
  }
}

// selectvfݒ肷
function setSelect(){
  planet1=document.getElementById('planet1');
  planet2=document.getElementById('planet2');
  for(var i=0;i<planets.length;i++){
    var opt1=document.createElement('option');
    opt1.value=i;
    opt1.text=planets[i].name;
    opt1.style.color='#'+planets[i].color;
    planet1.appendChild(opt1);
    var opt2=document.createElement('option');
    opt2.value=i;
    opt2.text=opt1.text;
    opt2.style.color=opt1.style.color;
    planet2.appendChild(opt2);
  }
  planet1.style.color='#'+planets[0].color;
  planet2.style.color='#'+planets[0].color;
}

// [v֐
var step=0;
function loop(){
  step++;
  viewModel.update();
  for(var i=0;i<planets.length;i++){
    planets[i].obj.update(viewModel.camera);
  }
  if(step%10===0) draw();
  requestAnimationFrame(loop);
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  context.fillStyle=FG_COLOR;
  drawDistance();
  drawCalendar();
  for(var i=0;i<planets.length;i++){
    planets[i].calculateCoordinates();
  }
}

// fԂ̋`悷
function drawDistance(){
  var d=planets[p1].distance(planets[p2]);
  var texts=['  '+d.toFixed(4)+'AU',' ='+parseInt(AU_TO_KM*d)+'km'];
  context.fillText(texts[0],LIFT_MARGIN,FONT_SIZE);
  context.fillText(texts[1],LIFT_MARGIN,2*FONT_SIZE);
}

// J_[`悷
function drawCalendar(){
  var date=new Date();
  julianDay=EPOCH_JD+MILLIS_TO_DAY*date.getTime();
  var mjd=julianDay-MJD_EPOCH;
  var texts=['JST:'+dateString(date.getFullYear(),date.getMonth(),
      	      	      	       date.getDate(),date.getHours(),
      	      	      	       date.getMinutes(),date.getSeconds()),
      	     'GMT:'+dateString(date.getUTCFullYear(),date.getUTCMonth(),
      	      	      	       date.getUTCDate(),date.getUTCHours(),
      	      	      	       date.getUTCMinutes(),date.getUTCSeconds()),
      	     'JD:'+julianDay.toFixed(4),
      	     'MJD:'+mjd.toFixed(4)];
  for(var i=0;i<4;i++){
    context.fillText(texts[i],LIFT_MARGIN,(5+i)*FONT_SIZE-2);
  }
}

// Ԃ
// yy,mm,dd,h,m,s - NE(-1)EEEEb
function dateString(yy,mm,dd,h,m,s){
  return yy+'/'+('0'+(mm+1)).slice(-2)+'/'+('0'+dd).slice(-2)+' '
      	+('0'+h).slice(-2)+':'+('0'+m).slice(-2)+':'+('0'+s).slice(-2);
}

// fI
function selectPlanet(){
  p1=parseInt(planet1.value);
  p2=parseInt(planet2.value);
  planet1.style.color='#'+planets[p1].color;
  planet2.style.color='#'+planets[p2].color;
}

// f|C^ړ
// index - |C^CfbNX
// dir - XgVtgl
function movePointer(index,dir){
  switch(index){
    case 0:
      p1=(p1+dir+planets.length)%planets.length;
      planet1.selectedIndex=p1;
      planet1.style.color='#'+planets[p1].color;
      break;
    default:
      p2=(p2+dir+planets.length)%planets.length;
      planet2.selectedIndex=p2;
      planet2.style.color='#'+planets[p2].color;
      break;
  }
  draw();
}

//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }
  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.labelRenderer=new THREE.CSS2DRenderer();
  this.labelRenderer.setSize(this.canvasFrame.clientWidth,
      	      	      	     this.canvasFrame.clientHeight);
  this.labelRenderer.domElement.style.position='absolute';
  this.labelRenderer.domElement.style.top='0';
  this.labelRenderer.domElement.style.pointerEvents='none';
  this.canvasFrame.appendChild(this.labelRenderer.domElement);

  this.renderer.setClearColor(0x000000,1.0);
  this.scene=new THREE.Scene();					// V[
  this.initLight();
  this.initCamera();
};

// 
ViewModel.prototype.initLight=function(){
// _@zSɐݒu
  this.pointLight=new THREE.PointLight(0xffffff,1);
  this.pointLight.position.set(0,0,0);
  this.scene.add(this.pointLight);
// 
  this.ambientLight=new THREE.AmbientLight(0x999999);
  this.scene.add(this.ambientLight);
};

// J
ViewModel.prototype.initCamera=function(){
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
// J
  this.camera=new THREE.PerspectiveCamera
    (30,aspect,0.1*viewPoint1,100*viewPoint2);
/*
  this.camera=new THREE.OrthographicCamera
    (-aspect*thres,aspect*thres,thres,-thres,
     -2*maxRadius,2*maxRadius);
*/
  this.camera.position.set(0,-viewPoint1,viewPoint1);
  this.camera.up.set(0,0,1);

// gbN{[Rg[
  this.trackball=new THREE.TrackballControls
      	      	   (this.camera,this.canvasFrame);
  this.trackball.screen.width=this.canvasFrame.clientWidth;
  this.trackball.screen.height=this.canvasFrame.clientHeight;
  var bdc=this.canvasFrame.getBoundingClientRect();
  this.trackball.screen.offetLeft=bdc.left;
  this.trackball.screen.offetTop=bdc.top;

  this.trackball.noRotate=false;
  this.trackball.rotateSpeed=4.0;
  this.trackball.noZoom=false;
  this.trackball.zoomSpeed=4.0;
  this.trackball.noPan=true;
  this.trackball.target.set(0,0,0);
  this.trackball.staticMoving=true;
  this.trackball.dynamicDampingFactor=0.3;
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// \XV
ViewModel.prototype.update=function(){
  this.trackball.update();
  this.renderer.render(this.scene,this.camera);
  this.labelRenderer.render(this.scene,this.camera);
};

// _Ԃɂ
ViewModel.prototype.initView=function(){
  this.camera.position.set(0,-viewPoint1,viewPoint1);
  this.camera.up.set(0,0,1);
  this.camera.updateProjectionMatrix();
};

// Ŝ\
ViewModel.prototype.viewAll=function(){
  this.camera.position.set(0,-viewPoint2,viewPoint2);
  this.camera.up.set(0,0,1);
  this.camera.updateProjectionMatrix();
};

//--------------------------------------------------------------------//
// ff[^
// name - f̖O
// color - \F
// radius - \a
// sma - Oa AU
// eccen - S
// lofp - ߓ_o(rad)
// lofan - _o(rad)
// inc - OXΊp(rad)
// meanl - ωo(rad)
// pinv - px(rad/)
var Planet=function(name,color,radius,sma,eccen,lofp,lofan,inc,meanl,pinv){
  this.name=name;
  this.color=color;
  this.radius=radius;
  this.sma=sma;
  this.eccen=eccen;
  this.lofp=lofp;
  this.lofan=lofan;
  this.inc=inc;
  this.meanl=meanl;
  this.pinv=pinv;
  this.pltype=SUN;
};

// f^Cv𔻕ʂ
// thres - fEOf臒l
Planet.prototype.setType=function(thres){
  if(this.sma===0.0){		// z
    this.pltype=SUN;
  }
  else if(this.sma<=thres){	// f
    this.pltype=INNER_PLANET;
  }
  else{				// Of
    this.pltype=OUTER_PLANET;
  }
};

// \IuWFNg쐬
// id - fԍ
Planet.prototype.createObject=function(id){
  this.obj=new THREE.LOD();
  var r=[0.03*this.radius,0.1*this.radius,0.15*this.radius,
      	 0.3*this.radius,0.5*this.radius];	// \fa
  var d=[thres,0.5*(thres+maxRadius),maxRadius,
      	 2*maxRadius,4*maxRadius];		// ؑ֋
  var material=new THREE.MeshStandardMaterial
    ({roughness:0.4,metalness:0.5});
  material.color.set(parseInt(this.color,16));
  if(this.pltype===SUN){
    material.side=THREE.BackSide;		// z͓\
  }
  for(var i=0;i<r.length;i++){
    var geometry=new THREE.SphereGeometry(r[i],36,18);
    var mesh=new THREE.Mesh(geometry,material);
    mesh.name=id;
    this.obj.addLevel(mesh,d[i]);
  }
  if(this.pltype!==SUN){
    this.createOrbit();
  }
};

// Ovf쐬
Planet.prototype.createOrbit=function(){
  var ccpa=Math.cos(this.lofp-this.lofan);
  var sspa=Math.sin(this.lofp-this.lofan);
  var cinc=1.0-Math.cos(this.inc);
  var sinc=Math.sin(this.inc);
  var ccan=Math.cos(this.lofan)*cinc;
  var ssan=Math.sin(this.lofan)*cinc;
  var ccp=Math.cos(this.lofp);
  var ssp=Math.sin(this.lofp);
  var m11=ccp+sspa*ssan;
  var m12=-ssp+ccpa*ssan;
  var m21=ssp-sspa*ccan;
  var m22=ccp-ccpa*ccan;
  var m31=sspa*sinc;
  var m32=ccpa*sinc;
  var smaY=this.sma*Math.sqrt(1.0-this.eccen*this.eccen);
  var cc=1.0;
  var ss=0.0;
  var dtheta=2.0*Math.PI/ORBIT_VIEW_COUNT;
  var dc=Math.cos(dtheta);
  var ds=Math.sin(dtheta);
  var vCount=3*(ORBIT_VIEW_COUNT+1);
  var vertices=new Float32Array(vCount);
  for(var i=0;i<vCount;i+=3){
    var x0=this.sma*(cc-this.eccen);
    var y0=smaY*ss;
    vertices[i]=m11*x0+m12*y0;
    vertices[i+1]=m21*x0+m22*y0;
    vertices[i+2]=m31*x0+m32*y0;
    var cctemp=cc*dc-ss*ds;
    var sstemp=ss*dc+cc*ds;
    cc=cctemp;
    ss=sstemp;
  }
  var geometry=new THREE.BufferGeometry();
  geometry.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.orbit=new THREE.Line(geometry,ORBIT_MAT);
};

// _Ԃ _ = Oa~( 1 + S)
Planet.prototype.getMaxRadius=function(){
  return this.sma*(1.0+this.eccen);
};

// ߓ_Ԃ ߓ_ = Oa~( 1 - S)
Planet.prototype.getMinRadius=function(){
  return this.sma*(1.0-this.eccen);
};

// fWʒuvZ
Planet.prototype.calculateCoordinates=function(){
  var m=this.meanl-this.lofp+this.pinv*(julianDay-epoch);  // ϋߓ_p
  var eeh=0.5*eccentricAnomaly(m,this.eccen);
  var v=Math.PI;
  if(Math.cos(eeh)!==0.0){
    var tanv=Math.sqrt((1.0+this.eccen)/(1.0-this.eccen));
    v=2.0*Math.atan(tanv*Math.tan(eeh));
  }
  v+=this.lofp;
  var lens=this.sma*(1.0-this.eccen*Math.cos(2.0*eeh));
  var ss=Math.sin(v-this.lofan);
  var cinc=1.0-Math.cos(this.inc);
  this.obj.position.set
    (lens*(Math.cos(v)+ss*Math.sin(this.lofan)*cinc),
     lens*(Math.sin(v)-ss*Math.cos(this.lofan)*cinc),
     lens*ss*Math.sin(this.inc));
};

// fƂ̋Ԃ
// pl - 𑪂Ώۂ̘f
Planet.prototype.distance=function(pl){
  return this.obj.position.distanceTo(pl.obj.position);
};

// Newton @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
function eccentricAnomaly(m,eccen){
  var ei=m+eccen*Math.sin(m);
  var mi=ei-eccen*Math.sin(ei);
  var dm=Math.abs(m-mi);
  while(dm>TOLERANCE){
    ei=ei+(m-mi)/(1.0-eccen*Math.cos(ei));
    mi=ei-eccen*Math.sin(ei);
    dm=Math.abs(m-mi);
  }
  return ei;
}

//--------------------------------------------------------------------//
// ڐ
var Scale=function(){
  this.obj=new THREE.Group();
  this.obj.position.set(0,0,0);
  var r=[1,5,10];
  var c=[0xffffff,0x333333,0x999999];
  var vertices=new Float32Array(3*(r.length+1));
  vertices[0]=0;
  vertices[1]=0;
  vertices[2]=0;
  for(var i=0;i<r.length;i++){
    var geometry=new THREE.SphereGeometry(r[i],36,18);
    var material=new THREE.MeshStandardMaterial
      ({roughness:0.4,metalness:0.3,transparent:true,opacity:0.3,
      	side:THREE.BackSide});
    material.color.set(c[i]);
    var sph=new THREE.Mesh(geometry,material);
    sph.position.set(0,0,0);
    this.obj.add(sph);
    var text=document.createElement('div');
    text.style.font=FONT;
    text.style.color=FG_COLOR;
    text.textContent=r[i]+'AU';
    var label=new THREE.CSS2DObject(text);
    label.position.set(0,0,r[i]);
    this.obj.add(label);
    vertices[3*i+3]=0;
    vertices[3*i+4]=0;
    vertices[3*i+5]=r[i];
  }
  var lineGeom=new THREE.BufferGeometry();
  lineGeom.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.obj.add(new THREE.Line(lineGeom,SCALE_AXIS_MAT));
};
